/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.dialog.control;

import java.awt.Button;
import java.awt.Label;

import org.gvsig.i18n.Messages;

import es.prodevelop.gvsig.mobile.gui.dialog.DialogConstants;

/**
 * This class represents a row in an expansible dialog containing
 * the accept and cancel buttons (normally it's the last row of the dialog)
 * 
 * @see es.prodevelop.gvsig.mobile.gui.dialog.control.ExpansibleRow
 * 
 * @author jcarrasco
 *
 */
public class AceptCancelRow extends ExpansibleRow {
	Button btCancelar;
	Button btAceptar; 
	
	/**
	 * Constructor. 
	 * 
	 * @param height height of this component (in pixels)
	 * @param p owner of this row. This parameter will also be the action listener of
	 * the buttons.
	 * 
	 */
	public AceptCancelRow(int height, ExpansibleDialog p){
		super(height);
		Label lbl5 = new Label(""); //$NON-NLS-1$
		lbl5.setSize(10,DialogConstants.CONTROL_HEIGHT);
		addExtensible(lbl5);
		
		btCancelar = new Button(Messages.getText("AceptCancelRow.1")); //$NON-NLS-1$
		btCancelar.setActionCommand("CANCEL"); //$NON-NLS-1$
		btCancelar.setSize(100,DialogConstants.CONTROL_HEIGHT);
		btCancelar.addActionListener(p);
		add(btCancelar);
		
		btAceptar = new Button(Messages.getText("AceptCancelRow.3")); //$NON-NLS-1$
		btAceptar.setActionCommand("ACCEPT"); //$NON-NLS-1$
		btAceptar.setSize(100,DialogConstants.CONTROL_HEIGHT);
		btAceptar.addActionListener(p);
		add(btAceptar);
		

	}


}
