/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.mainframe;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import org.apache.log4j.Logger;

/**
 * This class is used to listen to the events performed on the application
 *  main window, in case sdomething has to be done when they occur.
 *  
 *  @see es.prodevelop.gvsig.mobile.gui.mainframe.MainWindow
 *  
 * @author jldominguez
 *
 */
public class MainWindowAdapter extends WindowAdapter{
	private static Logger logger = Logger.getLogger(MainWindowAdapter.class);
	MainWindow win;
	
	/**
	 * COnstruntor
	 * @param win The mainwindow where events happen.
	 * 
	 */
	public MainWindowAdapter(MainWindow win){
		this.win=win;
	}
	public void windowActivated(WindowEvent e) {
		// logger.debug("windowActivated(e)");
	}

	
	public void windowClosing(WindowEvent e) {
		logger.debug("Closing (minimizing) window");
		// Stop tracklog if stopTrackingWhenMinimized
		win.winDeactivated();
	}

	public void windowDeiconified(WindowEvent e) {
		logger.debug("windowDeiconified(e)");
	}

	public void windowGainedFocus(WindowEvent e) {
		logger.debug("windowGainedFocus(e)");
	}

	public void windowOpened(WindowEvent e) {
		logger.debug("windowOpened(e)");
	}

	public void windowStateChanged(WindowEvent e) {
		logger.debug("windowStateChanged(e)");
	}
	public void windowDeactivated(WindowEvent e) {
		// TODO Auto-generated method stub
		super.windowDeactivated(e);
		win.winDeactivated();
	}
	public void windowIconified(WindowEvent e) {
		// TODO Auto-generated method stub
		super.windowIconified(e);
		win.winDeactivated();
	}
	public void windowLostFocus(WindowEvent e) {
		// TODO Auto-generated method stub
		super.windowLostFocus(e);
		//win.winDeactivated();
	}

}
