/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.tab;

import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;

import org.apache.log4j.Logger;

/**
 * This class contains the tabs in a <code>TabbedDialog</code>, simply
 * a row of labels (<code>TabLabel</code>) which listen to mouse events.
 * 
 * 
 * @see es.prodevelop.gvsig.mobile.gui.tab.TabbedPanel
 * @see es.prodevelop.gvsig.mobile.gui.tab.TabbedDialog
 * @see es.prodevelop.gvsig.mobile.gui.tab.TabLabel
 * 
 * @author jldominguez
 *
 */
public class TabbedPanelTopPanel extends Container {
	
	private static Logger logger = Logger.getLogger(TabbedPanelTopPanel.class);
	// private LastLabel lastl;
	private int minW;

	/**
	 * Constructor
	 * @param maxw the maximum width that this component should have
	 * 
	 */
	public TabbedPanelTopPanel(int maxw) {
		super();
		//setBackground(Color.blue);
		setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
		// setLayout(null);
		// lastl = new LastLabel(maxw); 
		// add(lastl);
	}
	
	/**
	 * Adds a new label to this component.
	 * 
	 * @param newTabLabel the new label to be added
	 */
	public void addTabLabel(TabLabel newTabLabel) {
		
		int count = getComponentCount();
		add(newTabLabel, count); // count - 1
		count++;
		
		int acum = 0;

		Component item = null;
		for (int i=0; i<(count-1); i++) {
			item = getComponent(i);
			// item.setBounds(acum, 0, item.getWidth(), item.getHeight());
			acum = acum + item.getWidth();
		}
		
		int lastw = getWidth() - acum;
		minW=acum;
		rewidth();
	}
	
	/**
	 * Refreshes the component layout.
	 *
	 */
	public void rewidth(){
		// lastl.setTextForSize(getWidth()-minW-4);  
		// lastl.setSize(getWidth()-minW-4, lastl.getHeight());
		doLayout();
	}
	
	/**
	 * Gets the first label of this components. It's simply used to check
	 * whether it is empty or not
	 * @return the first label of this components
	 */
	public TabLabel getFirst() {
		
		if (getComponentCount() > 1) {
			
			Component c = getComponent(0);
			if (c instanceof TabLabel) {
				return (TabLabel) c;
			} else {
				return null;
			}
			
		} else {
			return null;
		}
		
	}


	
}
