/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.tool;

import java.awt.event.MouseListener;

import org.apache.log4j.Logger;

/**
 * Class for all types of buttons in the application different from TBWidget
 * @author mmontesinos
 * 
 * @see GenericButton
 *
 */
public class DialogButton extends GenericButton {

	protected static Logger logger = Logger.getLogger(TBWidget.class);
	
	/**
	 * Constructs a new instance of this class given the icons and the
	 * listener of the events for this new instance
	 * @param _icon Name of the image to be loaded as <i>normal</i> image 
	 * @param _selicon Name of the image to be loaded as <i>selected</i>
	 * 				 image. Used when the button is selected
	 * @param ml Listener of Mouse Events, which must be a
	 * 				 <code>MouseListener</code>
	 */
	public DialogButton(String _icon, String _selicon, MouseListener ml) {
		super(_icon, _selicon, ml);
	}

	/*
	 * TODO
	 * add specific DialogButton features (Dialog Tool Bars?) If so,
	 * Generic Button should integrate with TBWidget and create a new
	 * DialogToolBar, moving up some features of ToolBar to a new abstract class
	 */
	
}