/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.tool;

import java.util.ArrayList;
import java.util.Iterator;

import es.prodevelop.gvsig.mobile.common.GvsigMobileGUIConstants;

/**
 * Utility class to perform the animation of the group button bar (to the left of the
 * main window)
 * 
 * @see es.prodevelop.gvsig.mobile.gui.tool.ToolBarGroupButton
 * 
 * @author jldominguez
 *
 */
public class GroupToolbar extends ArrayList {
	
	
	/**
	 * This method updates the position of the group buttons (to the left of the
	 * main window) by a small quantity.
	 * 
	 * @param quantity
	 */
	public void step(int quantity) {
		
		Iterator it = this.iterator();
		int maxy = -99999;
		while (it.hasNext()){
			ToolBarGroupButton gb = (ToolBarGroupButton)it.next();
			int newY = gb.getLocation().y - quantity;
			gb.setLocation(gb.getLocation().x,newY);
			if (newY > maxy) maxy = newY;
		}
		
		Iterator it2 = this.iterator();
		
		while (it2.hasNext()) {
			
			ToolBarGroupButton gb = (ToolBarGroupButton)it2.next();
			if (gb.getLocation().y <= -1 * GvsigMobileGUIConstants.DEFAULT_TB_GROUP_BUTTON_HEIGHT) {
				int newY = maxy + GvsigMobileGUIConstants.DEFAULT_TB_GROUP_BUTTON_HEIGHT;
				gb.setLocation(gb.getLocation().x,newY); 
				maxy = newY;
			}
		}
		
		
	}
}
