/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.tool.listener.imterfaces;

import es.prodevelop.gvsig.mobile.gui.tool.event.PointEvent;
import es.prodevelop.gvsig.mobile.gui.tool.event.RectangleEvent;

/**
 * This is the rectangle-oriented tool listener interface.
 * Each tool listenr will perform the corresponding
 * actions when the relevant rectangle event arrives.
 * 
 * 
 * @see es.prodevelop.gvsig.mobile.gui.tool.behavior.RectangleBehavior
 * 
 * @author jldominguez
 *
 */
public interface RectangleToolListener extends ToolListener {
	
	/**
	 * The method that will be called when a relevant rectangle event happens.
	 * Each tool listener will have to perform some actioon on the map,
	 * depending on the functionality of the tool.
	 * 
	 * @param event the relevant rectangle event the tool is waiting for.
	 */
	public void rectangle(RectangleEvent event);
	
	/**
	 * The rectangle event listener could also be interestd in point
	 * events.
	 * 
	 * @param event a certain point event that the listener could be interested in.
	 */
	public void point(PointEvent event);

}