package es.prodevelop.gvsig.mobile.fmap.core.acetate;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;

import es.prodevelop.gvsig.mobile.fmap.core.FPolyline2D;
import es.prodevelop.gvsig.mobile.fmap.core.GeneralPathX;
import es.prodevelop.gvsig.mobile.fmap.symbol.FSymbol;
import es.prodevelop.gvsig.mobile.fmap.util.graph2d.Graph2DUtilities;

public class AcetateTrail extends FPolyline2D implements IAcetateElement {
	
	public static final int MAX_VERTICES = 100;
	public static final Color ACETATE_TRAILER_COLOR = Color.RED;
	
	private int maxVertices;
	private GeneralPathX generalPath;
	
	private int nOfPoints = 0;
	private boolean visible = false;
	
	public AcetateTrail(int maxv, GeneralPathX gpx) {
		super(gpx);
		
		maxVertices = maxv;
		generalPath = gpx;
	}
	
	public void reset() {
		generalPath = new GeneralPathX();
		nOfPoints = 0;
	}
	
	public void addVertex(double x, double y) {
		if (nOfPoints == 0) {
			generalPath.moveTo(x, y);
		} else {
			generalPath.lineTo(x, y);
		}
		nOfPoints++;
	}

	public double getRotation() {
		return 0;
	}

	public void setRotation(double r) {
	}

	public void draw(Graphics2D g, AffineTransform at) {
		
		if ((nOfPoints == 0) || (!visible)) {
			return;
		}
		
		// System.out.println("Drawing TRAIL...");
		g.setColor(ACETATE_TRAILER_COLOR);
		Graph2DUtilities.drawPathIteratorLastVertices(
				g, generalPath.getPathIterator(at), null, nOfPoints, MAX_VERTICES);
	}

	public void setVisible(boolean b) {
		visible = b;
	}
	
	
	 

}
