package es.prodevelop.gvsig.mobile.fmap.core.acetate;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */


import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.util.Vector;

import javax.swing.plaf.basic.BasicSliderUI.TrackListener;

import org.apache.log4j.Logger;
import es.prodevelop.gvsig.mobile.fmap.core.acetate.IAcetateElement;

/**
 * This class contains the routepoints icons and name used on the map with geographic info.
 * 
 * @author manu
 */
public class MapRteIcon extends Component implements IAcetateElement{

	private static Logger logger = Logger.getLogger(MapRteIcon.class);

	private boolean visible = true;
	private double rotationDegrees = 0;

	private String name;
	private Vector trackpoints = new Vector(); //Point2D vector
	private Vector icon = new Vector(); //Image vector
	private Vector names = new Vector(); //String vector
	private int radius_x = 0;
	private int radius_y = 0;
	
	
	/**
	 * Constructor
	 * 
	 */
	public MapRteIcon(String s){
		name = s;
	}
	
	public void setRadius(Image icon)
	{
		radius_x = icon.getWidth(null) / 2;
		radius_y = icon.getHeight(null) / 2;
	}
		
//	public void paint(Graphics g) {
//		if (visible && trackpoints.size() > 0)  //&& icon.size() > 0 && names.size() > 0
//		{
//			Point2D geoPoint = (Point2D) trackpoints.get(0);
//			g.drawImage(icon, 0, 0, null);
//			g.drawString(name, 0, 0);
//			for(int i = 1; i < trackpoints.size(); i++)
//			{
//				geoPoint = (Point2D) trackpoints.get(i);
//				g.drawImage(icon, 0, 0, null);
//				logger.debug("Symbol Icon painted");	
//			}
//		}
//	}
		
	public void addXY(double x, double y, Image i, String n) {
		Point2D geoPoint = new Point2D.Double();
		geoPoint.setLocation(x, y);
		trackpoints.add(geoPoint);
		icon.add(i);
		names.add(n);
	}
		
	public Vector getTrackpoints(){
		return trackpoints;
	}
	
	/**
	 * @return the icon images
	 */
	public Vector getIcon() {
		return icon;
	}
	
	/**
	 * @return the icon name
	 */
	public String getName() {
		return name;
	}
		
	/**
	 * Sets the icon name.
	 */
	public void setName(String s) {
		name = s;
	}

	public double getRotation() {
		return rotationDegrees;
	}

	public void setRotation(double r) {
		rotationDegrees = r;
	}

	public void draw(Graphics2D g, AffineTransform at) {	
		if (visible && trackpoints.size()>0) //&& icon.size() > 0 && names.size() > 0
		{
			for(int i = 0; i < trackpoints.size(); i++)
			{
				Point2D geoPoint = (Point2D) trackpoints.get(i);
				Point2D aux = new Point2D.Double(0, 0);
				at.transform(geoPoint, aux);
				int screenx = (int) Math.round(aux.getX()) - radius_x;
				int screeny = (int) Math.round(aux.getY()) - radius_y;
				g.drawImage((Image)icon.get(i), screenx, screeny, null);
				String name2 = (String)names.get(i);
				g.drawString(name2, screenx-name2.length()*2, screeny);
				//g.drawLine(screenx_old+radius_x,screeny_old+radius_y, screenx+radius_x, screeny+radius_y);
				logger.debug("Symbol Icon painted");	
			}
		}
	}
	
	public void setVisible(boolean aux){
		visible=aux;
	}
}
