package es.prodevelop.gvsig.mobile.fmap.driver.raster.tile;

import java.awt.geom.Rectangle2D;
import java.net.URL;

import org.apache.log4j.Logger;

/**
 * This interface must be implemented by all tile objects.
 * 
 * @author jldominguez
 *
 */
public abstract class RemoteTile implements Cloneable {
	
	public static double SEMI_EQUATOR_LENGTH = 180.0;
	
	protected static Logger logger = Logger.getLogger(RemoteTile.class);
	
	public static final int PATH_TYPE_LEFT_TOP = 0; 
	public static final int PATH_TYPE_QUAD_TREE = 1;
	
	protected Rectangle2D.Double extent = null;
	
	protected RemoteTile() { }
	
	/**
	 * Gets path location.
	 * 
	 * @return
	 */
	public abstract URL getURL();
//	{
//		
//		URL resp = null;
//		
//		switch (pathType) {
//		case PATH_TYPE_LEFT_TOP:
//			resp = new URL();
//			break;
//			
//		case PATH_TYPE_QUAD_TREE:
//			resp = new URL();
//			break;
//		}
//		
//		logger.error("Unknown tile path type: " + pathType);
//		return null;
//	}
	
	public abstract RemoteTile getParentTile();
	public abstract RemoteTile getTileToTheEast();
	public abstract RemoteTile getTileToTheSouth();
	
	public Rectangle2D getExtent() {
		return extent;
	}
	
	public abstract Object clone();

}
