/*
 * Created on 19-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/

package es.prodevelop.gvsig.mobile.fmap.driver.vect.write;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.log4j.Logger;

/**
 *
 * This class keeps an array of the bytes to be written, to avoid output issues
 * found with JME.
 *  
 * @author Juan Lucas Dominguez Rubio, jldominguez@prodevelop.es
 */
public class BufferedOutputStream extends OutputStream {
	
	private static Logger logger = Logger.getLogger(BufferedOutputStream.class);
	
	private File outFile;
	private File tmpFile;
	
	public static int BUFFER_SIZE = 4096;
	private byte[] buffer = new byte[BUFFER_SIZE];
	private int index = 0;
	
	private FileOutputStream fos;
	
	public BufferedOutputStream(File outf) {
		outFile = outf;
		
		String name = "" + System.currentTimeMillis();
		try {
			tmpFile = File.createTempFile(name, ".tmp");
			tmpFile.deleteOnExit();
		} catch (Exception e1) {
			logger.error("While creating temp file: " + e1.getMessage());
		}
		
		try {
			fos = new FileOutputStream(tmpFile);
		} catch (FileNotFoundException e) {
			logger.error("Unable to create ouf stream: " + e.getMessage());
		}
	}

	public void write(int b) throws IOException {
		buffer[index] = (byte) b;
		index++;
		
		if (index == BUFFER_SIZE) {
			flushToFile();
		}
	}
	
	public void close() {
		
		if (fos == null) {
			return;
		}
		
		flushToFile();
		try {
			fos.close();
		} catch (IOException e) {
			logger.error("While closing fos: " + e.getMessage());
		}
		
		fos = null;
		try {
			logger.debug(System.currentTimeMillis() + "Copying file to destination: " + outFile.getAbsolutePath());
			copyFile(tmpFile, outFile);
			logger.debug(System.currentTimeMillis() + "Copying file to destination, done.");
		} catch (IOException e) {
			logger.error("While copying file: " + e.getMessage());
		}
	}

	void copyFile(File src, File dst) throws IOException {
		
		InputStream in = new FileInputStream(src);
        OutputStream out = new FileOutputStream(dst);
    
        // Transfer bytes from in to out
        byte[] buf = new byte[BUFFER_SIZE];
        int len;
        while ((len = in.read(buf)) > 0) {
            out.write(buf, 0, len);
        }
        in.close();
        out.close();
    }


	private void flushToFile() {
		
		if (fos == null) {
			return;
		}
		
		try {
			writeBuffer();
			fos.flush();
			index = 0;
		} catch (IOException e) {
			logger.error("While writing to file: " + e.getMessage());
		}
	}
	

	private void writeBuffer() throws IOException {
		
		fos.write(buffer, 0, index);

	}



}
