/*
 * Created on 19-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/
package es.prodevelop.gvsig.mobile.fmap.driver.vect.write;

import java.io.File;

import org.apache.log4j.Logger;

import es.prodevelop.gvsig.mobile.fmap.driver.vect.shp.MemoryShpDriver;
import es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter;
import es.prodevelop.gvsig.mobile.fmap.util.string.StringUtilities;

/**
 * This class creates SHP and SHX from a given VectorialEditableAdapter. Used when 
 * editing ends.
 *
 * @author Juan Lucas Dominguez Rubio, jldominguez@prodevelop.es
 * @author Vicente Caballero Navarro
 */
public class SHPSHXFromVEA {
	
	private static Logger logger = Logger.getLogger(SHPSHXFromVEA.class);
	
	private VectorialEditableAdapter theVEA = null;
	
	private String shpPath;
	private String shxPath;
	private int temp = 0;
	private int type;

	/**
	 * Crea un nuevo SHPSHXFromGeometries.
	 *
	 * @param geometries DOCUMENT ME!
	 * @param file DOCUMENT ME!
	 */
	public SHPSHXFromVEA(VectorialEditableAdapter vea, File file) {
		theVEA = vea;
		setFile(file);
	}

	//private FBitSet bitset = null;
	//private int num = 0;

	/**
	 * DOCUMENT ME!
	 *
	 * @param f DOCUMENT ME!
	 */
	private void setFile(File f) {
		shpPath = f.getAbsolutePath();
		String strFichshx = StringUtilities.replace(f.getAbsolutePath(), ".shp", ".shx");
		shxPath = StringUtilities.replace(strFichshx, ".SHP", ".SHX");
		
	}

	/**
	 * DOCUMENT ME!
	 */

	/*public void setType(int i) {
	   type = i;
	   }
	 */

	/**
	 * Finaliza el visitor.
	 */
	public void create() {
		SHPFileWrite filewrite;

		try {
			filewrite = new SHPFileWrite(
					new File(shpPath),
					new File(shxPath)
					);

			if (theVEA.getShapeCount() > 0) {
				MemoryShpDriver drv = (MemoryShpDriver) theVEA.getDriver();
				int type = drv.getSHPShapeType();
				filewrite.write(theVEA, type);
				filewrite.close();
			}
		} catch (Exception e1) {
			logger.error("While writing SHP/SHX: " + e1.getMessage());
		}

		logger.debug("Wrote SHP, SHX");
	}


}
