package es.prodevelop.gvsig.mobile.fmap.edition;

import java.io.IOException;
import java.util.Properties;

import com.hardcode.driverManager.Driver;

import es.prodevelop.gvsig.mobile.fmap.driver.ITableDefinition;

public interface IWriter extends Driver{
	void preProcess() throws IOException;

	/**
	 * Aqu dentro se puede hacer el chequeo de las reglas asignadas para que
	 * antes de guardar algo, se compruebe que es correcto. Aunque lo ideal
	 * sera haberlo hecho antes, para que lo que se guarde est corregido al
	 * mximo.
	 * @throws ProcessWriterVisitorException TODO
	 * @throws VisitorException
	 */
	void process(IRowEdited row) throws IOException;

	void postProcess() throws IOException;

	/**
	 * A developer can use this Properties for his own purposes. For example, to
	 * let his extension know something about one writer.
	 * <br>
	 * We can found for example:
	 * <br>
	 * <b>FieldNameMaxLength<b>: Maximum length of field name (Null or 0 --> unlimited).
	 *
	 * @param capability
	 * @return A message describing the capability. Null if not supported.
	 */
	public String getCapability(String capability);

	/**
	 * @param capabilities The capabilities to set.
	 */
	public void setCapabilities(Properties capabilities);


	public abstract boolean canWriteAttribute(int sqlType);
	public abstract boolean canAlterTable();
	public abstract boolean canSaveEdits() throws IOException;

	public void initialize(ITableDefinition tableDefinition) throws IOException;

	public ITableDefinition getTableDefinition() throws IOException;

	/**
	 * @return true if the driver needs to iterate trhu all records.
	 * for example, shp files need return true. jdbc writers will return false
	 */
	public boolean isWriteAll();


}
