package es.prodevelop.gvsig.mobile.fmap.edition.commands;

import java.io.IOException;

import es.prodevelop.gvsig.mobile.fmap.core.IRow;
import es.prodevelop.gvsig.mobile.fmap.edition.EditableAdapter;
import es.prodevelop.gvsig.mobile.fmap.edition.EditionEvent;

public class ModifyRowCommand extends AbstractCommand {

	private EditableAdapter efs;
	private IRow rowNext;
	private int calculatedIndexAnt;
	private int previousIndexInExpansionFile;
	private int type=EditionEvent.GRAPHIC;
	/**
	 * @param ef IEditableSource
	 * @param calculatedIndex index of modified row
	 * @param p previous index in expansion file. -1 if previous is from original data source.
	 * @param newRow
	 * @throws IOException
	 * @throws DriverIOException
	 */
	public ModifyRowCommand(EditableAdapter ef,int calculatedIndex,int previousInExpansionFile,IRow newRow,int type){
		super();
		efs=ef;
		calculatedIndexAnt=calculatedIndex;
		rowNext=newRow;
		previousIndexInExpansionFile=previousInExpansionFile;
		this.type=type;
	}
	/**
	 * @throws DriverIOException
	 * @throws IOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#undo()
	 */
	public void undo() throws IOException {
		efs.undoModifyRow(calculatedIndexAnt,previousIndexInExpansionFile,type);
	}
	/**
	 * @throws DriverIOException
	 * @throws IOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#redo()
	 */
	public void redo() throws IOException {
			efs.doModifyRow(calculatedIndexAnt,rowNext,type);
	}

	public String getType() {
		return "Modify";
	}
}
