package es.prodevelop.gvsig.mobile.fmap.layer;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;
import java.util.HashMap;
import java.util.Iterator;

import es.prodevelop.gvsig.mobile.fmap.core.GeneralPathX;
import es.prodevelop.gvsig.mobile.fmap.core.acetate.AcetateTrail;
import es.prodevelop.gvsig.mobile.fmap.core.acetate.IAcetateElement;
import es.prodevelop.gvsig.mobile.fmap.driver.FMapDriverException;
import es.prodevelop.gvsig.mobile.fmap.symbol.FSymbol;
import es.prodevelop.gvsig.mobile.fmap.viewport.ViewPort;


public class FAcetateLayer extends FLyrDefault {
	
	public static final String GPS_CURSOR_ACETATE_ID = "GPS_CURSOR_ACETATE_ID";
	
	private HashMap elements = new HashMap();
	private HashMap symbols = new HashMap();
	
	private FAcetateLayer() { }
	
	public FAcetateLayer(boolean add_gps) {
		
		if (add_gps) {
			addElement(new AcetateTrail(5, new GeneralPathX()), null, GPS_CURSOR_ACETATE_ID);
		}
		
	}
	
	public void addElement(IAcetateElement elem, FSymbol sym, String id) {
		elements.put(id, elem);
		symbols.put(id, sym);
	}
	
	public IAcetateElement getElement(String id) {
		return (IAcetateElement) elements.get(id);
	}


	public void draw(
			Graphics2D g,
			ViewPort viewPort) throws FMapDriverException {
		
		Iterator iter = elements.keySet().iterator();
		while (iter.hasNext()) {
			String key = (String) iter.next();
			IAcetateElement elem = (IAcetateElement) elements.get(key);
			FSymbol sym = (FSymbol) symbols.get(key);
			elem.draw(g, viewPort.getAffineTransform());
		}
	}

	public long getId() {
		// TODO Auto-generated method stub
		return 0;
	}


	public Rectangle2D getFullExtent() throws FMapDriverException {
		// TODO Auto-generated method stub
		return null;
	}


	public boolean isWritable() {
		// TODO Auto-generated method stub
		return false;
	}


	public void wakeUp(boolean driver_is_already_open) {
		// TODO Auto-generated method stub
		
	}


	public StringBuffer toXML(String name, String proyectPath) {
		// TODO Auto-generated method stub
		return null;
	}


	public void clean() {
		// TODO Auto-generated method stub
		
	}
	
	//by manu
	public void deleteElement(String id) {
		elements.remove(id);
		symbols.remove(id);
	}

	public void setGPSTrailerVisible(boolean b) {
		AcetateTrail at = (AcetateTrail) elements.get(GPS_CURSOR_ACETATE_ID); 
		if (at != null) {
			at.setVisible(b);
		}
	}

	public void clearGPSTrailer() {
		AcetateTrail at = (AcetateTrail) elements.get(GPS_CURSOR_ACETATE_ID); 
		if (at != null) {
			at.reset();
		}
	}

	public String getCustomForm() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setCustomFormActive(boolean state) {
		// TODO Auto-generated method stub
		
	}
	

}
