/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/

package es.prodevelop.gvsig.mobile.fmap.legend;

import java.awt.Color;
import java.util.ArrayList;

import com.hardcode.gdbms.engine.data.DataSource;

import es.prodevelop.gvsig.mobile.fmap.core.FShape;
import es.prodevelop.gvsig.mobile.fmap.core.IFeature;
import es.prodevelop.gvsig.mobile.fmap.symbol.FSymbol;
//import es.prodevelop.gvsig.mobile.fmap.util.xml.XMLEntity;
//import es.prodevelop.gvsig.mobile.fmap.util.xml.XMLException;

public class SingleSymbolLegend implements VectorialLegend, Legend{
	
	private FSymbol defaultSymbol = new FSymbol(Color.BLUE, Color.BLUE, true, 1);
	private String labelFieldName = null;
	private String labelFieldHeight = null;
	private String labelFieldRotation = null;
	private int shapeType = FShape.POLYGON; // Por defecto, tipo polgono
	// private boolean bWithHeightText;
	/**
	 * Crea un nuevo SingleSymbolLegend.
	 *
	 * @param style Smbolo.
	 */
	public SingleSymbolLegend(FSymbol style) {
		defaultSymbol = style;
	}

	/**
	 * Crea un nuevo SingleSymbolLegend.
	 */
	private SingleSymbolLegend() {
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#setDefaultSymbol(ISymbol)
	 */
	public void setDefaultSymbol(FSymbol s) {
		defaultSymbol = s;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#getLabelField()
	 */
	public String getLabelField() {
		return labelFieldName;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#setLabelField(int)
	 */
	public void setLabelField(String fieldName) {
		labelFieldName = fieldName;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#getSymbol(int)
	 */
	public FSymbol getSymbol(int recordIndex) {
		return defaultSymbol;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.Legend#getDefaultSymbol()
	 */
	public FSymbol getDefaultSymbol() {
		return defaultSymbol;
	}

	/**
	 * creates the SLD String that defines this legend type.
	 */
	
	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.Legend#getXMLEntity()
	 *//*
	public XMLEntity getXMLEntity() {
		XMLEntity xml = new XMLEntity();
		xml.putProperty("className",this.getClass().getName());
		xml.putProperty("labelFieldName", labelFieldName);
        xml.putProperty("labelHeightFieldName", labelFieldHeight);
        xml.putProperty("labelRotationFieldName", labelFieldRotation);
		

		return xml;
	}*/

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#setXMLEntity()
	 *//*
	public void setXMLEntity03(XMLEntity xml) {
		setLabelField(xml.getStringProperty("labelFieldName"));
	}*/

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#setXMLEntity()
	 *//*
	public void setXMLEntity(XMLEntity xml) {
		setLabelField(xml.getStringProperty("labelFieldName"));
        if (xml.contains("labelHeightFieldName"))
            setLabelHeightField(xml.getStringProperty("labelHeightFieldName"));
        if (xml.contains("labelRotationFieldName"))
            setLabelRotationField(xml.getStringProperty("labelRotationFieldName"));

	}*/

	/**
	 * @see com.iver.cit.gvsig.fmap.rendering.Legend#cloneLegend()
	 *//*
	public Legend cloneLegend() throws XMLException {
		return (Legend) LegendFactory.createSingleSymbolLegend();
	}*/
	
	public Legend cloneLegend() {
		//TODO:
		return null;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#setDataSource(com.hardcode.gdbms.engine.data.DataSource)
	 */
	public void setDataSource(DataSource ds) {
		// No hacemos nada, no lo vamos a usar
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#getShapeType()
	 */
	public int getShapeType() {
		return shapeType;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#setShapeType(int)
	 */
	public void setShapeType(int shapeType) {
	
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#getLabelHeightField()
	 */
	public String getLabelHeightField() {
		return labelFieldHeight;
	}

	/**
	 * Inserta el texto que refleja el alto del campo.
	 *
	 * @param str String.
	 */
	public void setLabelHeightField(String str) {
		labelFieldHeight = str;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#getLabelRotationField()
	 */
	public String getLabelRotationField() {
		return labelFieldRotation;
	}

	/**
	 * Inserta el texto que refleja la rotacin del campo.
	 *
	 * @param str String.
	 */
	public void setLabelRotationField(String str) {
		labelFieldRotation = str;
	}

    public FSymbol getSymbolByFeature(IFeature feat) {
        return defaultSymbol;
    }

	public void useDefaultSymbol(boolean b) {
		// TODO Auto-generated method stub
	}

    /* (non-Javadoc)
     * @see com.iver.cit.gvsig.fmap.rendering.VectorialLegend#getUsedFields()
     */
    public String[] getUsedFields() {
        ArrayList usedFields = new ArrayList();
        if (getLabelField() != null)
            usedFields.add(getLabelField());
        if (getLabelHeightField() != null)
            usedFields.add(getLabelHeightField());
        if (getLabelRotationField() != null)
            usedFields.add(getLabelRotationField());
                
        return (String[]) usedFields.toArray(new String[0]);
    }

	/* public boolean isBWithHeightText() {
		return bWithHeightText;
	}

	public void setBWithHeightText(boolean withHeightText) {
		bWithHeightText = withHeightText;
	} */
}
