/*
 * Created on 08-jun-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/

package es.prodevelop.gvsig.mobile.fmap.symbol;

import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.Area;
import java.awt.geom.NoninvertibleTransformException;
import java.awt.geom.PathIterator;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.lang.reflect.Array;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.vividsolutions.jts.algorithm.CGAlgorithms;
import com.vividsolutions.jts.algorithm.RobustCGAlgorithms;
import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.CoordinateArrays;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryCollection;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.LinearRing;
import com.vividsolutions.jts.geom.MultiLineString;
import com.vividsolutions.jts.geom.MultiPolygon;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.geom.Polygon;

import es.prodevelop.gvsig.mobile.fmap.core.FPoint2D;
import es.prodevelop.gvsig.mobile.fmap.core.FPolygon2D;
import es.prodevelop.gvsig.mobile.fmap.core.FPolyline2D;
import es.prodevelop.gvsig.mobile.fmap.core.FShape;
import es.prodevelop.gvsig.mobile.fmap.core.GeneralPathX;
import es.prodevelop.gvsig.mobile.fmap.core.IGeometry;
import es.prodevelop.gvsig.mobile.fmap.core.ShapeFactory;


/**
 * Clase con varios mtodos estticos utilizados para pasar de java2d a jts y
 * viceversa.
 *
 * @author fjp
 */
public class FConverter {
	
	private static Logger logger = Logger.getLogger(FConverter.class);
	/**
	 * QU PODEMOS HACER CON LOS MULTIPOINT??? => DEBERAMOS TRABAJAR CON UN
	 * ARRAY DE PUNTOS EN FShape.....Pensarlo bien.
	 */
	public final static GeometryFactory geomFactory = new GeometryFactory();
	public static CGAlgorithms cga = new RobustCGAlgorithms();
	// private final static AffineTransform at = new AffineTransform();
	private static double POINT_MARKER_SIZE = 3.0;

	/**
	 * Es la mxima distancia que permitimos que el trazo aproximado
	 * difiera del trazo real.
	 */
	public static double FLATNESS =0.8;// Por ejemplo. Cuanto ms pequeo, ms segmentos necesitar la curva


	//returns true if testPoint is a point in the pointList list.
	static boolean pointInList(Coordinate testPoint, Coordinate[] pointList) {
		int t;
		int numpoints;
		Coordinate p;

		numpoints = Array.getLength(pointList);

		for (t = 0; t < numpoints; t++) {
			p = pointList[t];

			if ((testPoint.x == p.x) && (testPoint.y == p.y) &&
					((testPoint.z == p.z) || (!(testPoint.z == testPoint.z))) //nan test; x!=x iff x is nan
			) {
				return true;
			}
		}

		return false;
	}

	/**
	 * Receives a JTS Geometry and returns a fmap IGeometry
	 * @param jtsGeometry jts Geometry
	 * @return IGeometry of FMap
	 * @author azabala
	 */
	

	/**
	 * Convierte un FShape a una Geometry del JTS. Para ello, utilizamos un
	 * "flattened PathIterator". El flattened indica que las curvas las pasa a
	 * segmentos de lnea recta AUTOMATICAMENTE!!!.
	 *
	 * @param shp FShape que se quiere convertir.
	 *
	 * @return Geometry de JTS.
	 */
	

	/**
	 * Converts JTS Geometry objects into Java 2D Shape objects
	 *
	 * @param geo Geometry de JTS.
	 *
	 * @return FShape.
	 */
	
	/**
	 * 
	 *
	 * @param p 
	 *
	 * @return 
	 */
	private static GeneralPathX toShape(Polygon p) {
		GeneralPathX resul = new GeneralPathX();
		Coordinate coord;

		for (int i = 0; i < p.getExteriorRing().getNumPoints(); i++) {
			coord = p.getExteriorRing().getCoordinateN(i);

			if (i == 0) {
				resul.moveTo(coord.x,coord.y);
			} else {
				resul.lineTo(coord.x,coord.y);
			}
		}

		for (int j = 0; j < p.getNumInteriorRing(); j++) {
			LineString hole = p.getInteriorRingN(j);

			for (int k = 0; k < hole.getNumPoints(); k++) {
				coord = hole.getCoordinateN(k);

				if (k == 0) {
					resul.moveTo(coord.x, coord.y);
				} else {
					resul.lineTo(coord.x, coord.y);
				}
			}
		}

		return resul;
	}

	/**
	 * 
	 *
	 * @param modelCoordinates 
	 *
	 * @return 
	 *
	 * @throws NoninvertibleTransformException 
	 *
	private Coordinate[] toViewCoordinates(Coordinate[] modelCoordinates)
		throws NoninvertibleTransformException {
		Coordinate[] viewCoordinates = new Coordinate[modelCoordinates.length];

		for (int i = 0; i < modelCoordinates.length; i++) {
			FPoint2D point2D = coordinate2FPoint2D(modelCoordinates[i]);
			viewCoordinates[i] = new Coordinate(point2D.getX(), point2D.getY());
		}

		return viewCoordinates;
	} */

	/* private Shape toShape(GeometryCollection gc)
	   throws NoninvertibleTransformException {
	   GeometryCollectionShape shape = new GeometryCollectionShape();
	   for (int i = 0; i < gc.getNumGeometries(); i++) {
	           Geometry g = (Geometry) gc.getGeometryN(i);
	           shape.add(toShape(g));
	   }
	   return shape;
	   } */
	private static GeneralPathX toShape(MultiLineString mls)
		throws NoninvertibleTransformException {
		GeneralPathX path = new GeneralPathX();

		for (int i = 0; i < mls.getNumGeometries(); i++) {
			LineString lineString = (LineString) mls.getGeometryN(i);
			path.append(toShape(lineString), false);
		}

		//BasicFeatureRenderer expects LineStrings and MultiLineStrings to be
		//converted to GeneralPathXs. [Jon Aquino]
		return path;
	}

	/**
	 * 
	 *
	 * @param lineString 
	 *
	 * @return 
	 *
	 * @throws NoninvertibleTransformException 
	 */
	private static GeneralPathX toShape(LineString lineString)
		throws NoninvertibleTransformException {
		GeneralPathX shape = new GeneralPathX();
		FPoint2D viewPoint = coordinate2FPoint2D(lineString.getCoordinateN(0));
		shape.moveTo(viewPoint.getX(), viewPoint.getY());

		for (int i = 1; i < lineString.getNumPoints(); i++) {
			viewPoint = coordinate2FPoint2D(lineString.getCoordinateN(i));
			shape.lineTo(viewPoint.getX(), viewPoint.getY());
		}

		//BasicFeatureRenderer expects LineStrings and MultiLineStrings to be
		//converted to GeneralPathXs. [Jon Aquino]
		return shape;
	}

	/**
	 * 
	 *
	 * @param point 
	 *
	 * @return 
	 *
	 * @throws NoninvertibleTransformException 
	 */
	private static FPoint2D toShape(Point point)
		throws NoninvertibleTransformException {
		FPoint2D viewPoint = coordinate2FPoint2D(point.getCoordinate());

		return viewPoint;
	}

	private static GeneralPathX toShape(MultiPolygon mp)
	throws NoninvertibleTransformException {
	GeneralPathX path = new GeneralPathX();

	for (int i = 0; i < mp.getNumGeometries(); i++) {
		Polygon polygon = (Polygon) mp.getGeometryN(i);
		path.append(toShape(polygon), false);
	}

	//BasicFeatureRenderer expects LineStrings and MultiLineStrings to be
	//converted to GeneralPathXs. [Jon Aquino]
	return path;
}
	/**
	 * 
	 *
	 * @param coord 
	 *
	 * @return 
	 */
	public static FPoint2D coordinate2FPoint2D(Coordinate coord) {
		return new FPoint2D(coord.x, coord.y); //,coord.z);
	}

	/**
	 * Convierte una Geometry de JTS a GeneralPathX.
	 *
	 * @param geometry Geometry a convertir.
	 *
	 * @return GeneralPathX.
	 *
	 * @throws NoninvertibleTransformException
	 * @throws IllegalArgumentException
	 */
	public static GeneralPathX toShape(Geometry geometry)
		throws NoninvertibleTransformException {
		if (geometry.isEmpty()) {
			return new GeneralPathX();
		}

		if (geometry instanceof Polygon) {
			return toShape((Polygon) geometry);
		}

		if (geometry instanceof MultiPolygon) {
			return toShape((MultiPolygon) geometry);
		}

		if (geometry instanceof LineString) {
			return toShape((LineString) geometry);
		}

		if (geometry instanceof MultiLineString) {
			return toShape((MultiLineString) geometry);
		}

		if (geometry instanceof GeometryCollection) {
			return toShape((GeometryCollection) geometry);
		}

		throw new IllegalArgumentException("Unrecognized Geometry class: " +
			geometry.getClass());
	}


    public static GeneralPathX transformToInts(GeneralPathX gp, AffineTransform at) {
        GeneralPathX newGp = new GeneralPathX();
        PathIterator theIterator;
        int theType;
        int numParts = 0;
        double[] theData = new double[6];
        Point2D ptDst = new Point2D.Double();
        Point2D ptSrc = new Point2D.Double();
        boolean bFirst = true;
        int xInt, yInt, antX = -1, antY = -1;

        theIterator = gp.getPathIterator(null); //, flatness);

        while (!theIterator.isDone()) {
            theType = theIterator.currentSegment(theData);
            switch (theType) {
                case PathIterator.SEG_MOVETO:
                    numParts++;
                    ptSrc.setLocation(theData[0], theData[1]);
                    at.transform(ptSrc, ptDst);
                    antX = (int) ptDst.getX();
                    antY = (int) ptDst.getY();
                    newGp.moveTo(antX, antY);
                    bFirst = true;
                    break;

                case PathIterator.SEG_LINETO:
                    ptSrc.setLocation(theData[0], theData[1]);
                    at.transform(ptSrc, ptDst);
                    xInt = (int) ptDst.getX();
                    yInt = (int) ptDst.getY();
                    if ((bFirst) || ((xInt != antX) || (yInt != antY)))
                    {
                        newGp.lineTo(xInt, yInt);
                        antX = xInt;
                        antY = yInt;
                        bFirst = false;
                    }
                    break;

                case PathIterator.SEG_QUADTO:
                    logger.error("Not supported here SEG_QUADTO");

                    break;

                case PathIterator.SEG_CUBICTO:
                	logger.error("Not supported here SEG_CUBICTO");

                    break;

                case PathIterator.SEG_CLOSE:
                    newGp.closePath();

                    break;
            } //end switch

            theIterator.next();
        } //end while loop

        return newGp;
    }
    public static FShape transformToInts(IGeometry gp, AffineTransform at) {
        GeneralPathX newGp = new GeneralPathX();
        double[] theData = new double[6];
        double[] aux = new double[6];

        // newGp.reset();
        PathIterator theIterator;
        int theType;
        int numParts = 0;

        Point2D ptDst = new Point2D.Double();
        Point2D ptSrc = new Point2D.Double();
        boolean bFirst = true;
        int xInt, yInt, antX = -1, antY = -1;


        theIterator = gp.getPathIterator(null); //, flatness);
        int numSegmentsAdded = 0;
        while (!theIterator.isDone()) {
            theType = theIterator.currentSegment(theData);

            switch (theType) {
                case PathIterator.SEG_MOVETO:
                    numParts++;
                    ptSrc.setLocation(theData[0], theData[1]);
                    at.transform(ptSrc, ptDst);
                    antX = (int) ptDst.getX();
                    antY = (int) ptDst.getY();
                    newGp.moveTo(antX, antY);
                    numSegmentsAdded++;
                    bFirst = true;
                    break;

                case PathIterator.SEG_LINETO:
                    ptSrc.setLocation(theData[0], theData[1]);
                    at.transform(ptSrc, ptDst);
                    xInt = (int) ptDst.getX();
                    yInt = (int) ptDst.getY();
                    if ((bFirst) || ((xInt != antX) || (yInt != antY)))
                    {
                        newGp.lineTo(xInt, yInt);
                        antX = xInt;
                        antY = yInt;
                        bFirst = false;
                        numSegmentsAdded++;
                    }
                    break;

                case PathIterator.SEG_QUADTO:
                    at.transform(theData,0,aux,0,2);
                    newGp.quadTo(aux[0], aux[1], aux[2], aux[3]);
                    numSegmentsAdded++;
                    break;

                case PathIterator.SEG_CUBICTO:
                    at.transform(theData,0,aux,0,3);
                    newGp.curveTo(aux[0], aux[1], aux[2], aux[3], aux[4], aux[5]);
                    numSegmentsAdded++;
                    break;

                case PathIterator.SEG_CLOSE:
                    if (numSegmentsAdded < 3)
                        newGp.lineTo(antX, antY);
                    newGp.closePath();

                    break;
            } //end switch

            theIterator.next();
        } //end while loop
        FShape shp = null;
        switch (gp.getGeometryType())
        {
            case FShape.POINT: //Tipo punto
            case FShape.POINT + FShape.Z:
                shp = new FPoint2D(ptDst.getX(), ptDst.getY());
                break;

            case FShape.LINE:
            case FShape.LINE + FShape.Z:
            case FShape.ARC:
            	shp = new FPolyline2D(newGp);
                break;

            case FShape.POLYGON:
            case FShape.POLYGON + FShape.Z:
            case FShape.CIRCLE:
            case FShape.ELLIPSE:

                shp = new FPolygon2D(newGp);
                break;
        }
        return shp;
    }

    public static Rectangle2D convertEnvelopeToRectangle2D(Envelope jtsR)
    {
        Rectangle2D.Double r = new Rectangle2D.Double(jtsR.getMinX(),
                jtsR.getMinY(), jtsR.getWidth(), jtsR.getHeight());
        return r;
    }

    public static Envelope convertRectangle2DtoEnvelope(Rectangle2D r)
    {
    	Envelope e = new Envelope(r.getX(), r.getX() + r.getWidth(), r.getY(),
			r.getY() + r.getHeight());
    	return e;
    }

    /**
     * Return a correct polygon (no hole)
     * @param coordinates
     * @return
     */
    public static IGeometry getExteriorPolygon(Coordinate[] coordinates)
    {
    	// isCCW = true => it's a hole
    	Coordinate[] vs=new Coordinate[coordinates.length];
        if (CGAlgorithms.isCCW(coordinates)){
        	for (int i=vs.length-1;i>=0;i--){
        		vs[i]=coordinates[i];
        	}
        }else{
        	vs=coordinates;
        }
        LinearRing ring = geomFactory.createLinearRing(vs);

        try {
			return ShapeFactory.createPolygon2D(toShape(ring));
		} catch (NoninvertibleTransformException e) {
			e.printStackTrace();
		}
		return null;
    }

    public static boolean isCCW(Point2D[] points)
    {
    	Coordinate[] vs=new Coordinate[points.length];
    	for (int i=points.length-1;i>=0;i--){
    		vs[i] = new Coordinate(points[i].getX(), points[i].getY());
    	}

        return CGAlgorithms.isCCW(vs);
    }

    public static boolean isCCW(FPolygon2D pol)
    {
    	return true;
    }


    /**
     * Return a hole (CCW ordered points)
     * @param coordinates
     * @return
     */
    public static IGeometry getHole(Coordinate[] coordinates)
    {
    	// isCCW = true => it's a hole
    	Coordinate[] vs=new Coordinate[coordinates.length];
        if (CGAlgorithms.isCCW(coordinates)){
        	vs=coordinates;

        }else{
        	for (int i=vs.length-1;i>=0;i--){
        		vs[i]=coordinates[i];
        	}
        }
        LinearRing ring = geomFactory.createLinearRing(vs);

        try {
			return ShapeFactory.createPolygon2D(toShape(ring));
		} catch (NoninvertibleTransformException e) {
			e.printStackTrace();
		}
		return null;
    }

	public static Shape getExteriorPolygon(GeneralPathX gp) {
		Area area = new Area(gp);
		area.isSingular();
		return area;



	}
	/**
	 * Use it ONLY for NOT multipart polygons.
	 * @param pol
	 * @return
	 */
	public static IGeometry getNotHolePolygon(FPolygon2D pol) {
		// isCCW == true => hole
		Coordinate[] coords;
		ArrayList arrayCoords = null;
		int theType;
		int numParts = 0;

		//	 	Use this array to store segment coordinate data
		double[] theData = new double[6];
		PathIterator theIterator;

				ArrayList shells = new ArrayList();
				ArrayList holes = new ArrayList();
				Coordinate[] points = null;

				theIterator = pol.getPathIterator(null, FLATNESS);

				while (!theIterator.isDone()) {
					//while not done
					theType = theIterator.currentSegment(theData);

					//Populate a segment of the new
					// GeneralPathX object.
					//Process the current segment to populate a new
					// segment of the new GeneralPathX object.
					switch (theType) {
						case PathIterator.SEG_MOVETO:

							// System.out.println("SEG_MOVETO");
							if (arrayCoords == null) {
								arrayCoords = new ArrayList();
							} else {
								points = CoordinateArrays.toCoordinateArray(arrayCoords);

								try {
									LinearRing ring = geomFactory.createLinearRing(points);

									if (CGAlgorithms.isCCW(points)) {
										holes.add(ring);
									} else {
										shells.add(ring);
									}
								} catch (Exception e) {
									logger.error("Catch topology exception in GMLLinearRingHandler");

									return null;
								}

								/* if (numParts == 1)
								   {
								           linRingExt = new GeometryFactory().createLinearRing(
								                  CoordinateArrays.toCoordinateArray(arrayCoords));
								   }
								   else
								   {
								           linRing = new GeometryFactory().createLinearRing(
								                          CoordinateArrays.toCoordinateArray(arrayCoords));
								           arrayLines.add(linRing);
								   } */
								arrayCoords = new ArrayList();
							}

							numParts++;
							arrayCoords.add(new Coordinate(theData[0],
									theData[1]));

							break;

						case PathIterator.SEG_LINETO:

							// System.out.println("SEG_LINETO");
							arrayCoords.add(new Coordinate(theData[0],
									theData[1]));

							break;

						case PathIterator.SEG_QUADTO:
							logger.error("SEG_QUADTO Not supported here");

							break;

						case PathIterator.SEG_CUBICTO:
							logger.error("SEG_CUBICTO Not supported here");

							break;

						case PathIterator.SEG_CLOSE:

							// Aadimos el primer punto para cerrar.
							Coordinate firstCoord = (Coordinate) arrayCoords.get(0);
							arrayCoords.add(new Coordinate(firstCoord.x,
									firstCoord.y));

							break;
					} //end switch

					// System.out.println("theData[0] = " + theData[0] + " theData[1]=" + theData[1]);
					theIterator.next();
				} //end while loop

				arrayCoords.add(arrayCoords.get(0));
				coords = CoordinateArrays.toCoordinateArray(arrayCoords);


		if (numParts == 1)
		{
			return getExteriorPolygon(coords);
		}
		return ShapeFactory.createGeometry(pol);

	}


    /* public static GeometryCollection convertFGeometryCollection(FGeometryCollection fGeomC)
    {

        geomFactory.createGeometryCollection(theGeoms);
    } */
}
