/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

package es.prodevelop.gvsig.mobile.gpe.util;

import com.hardcode.gdbms.engine.values.Value;
import com.hardcode.gdbms.engine.values.ValueFactory;

/********************************************************
 * GPETypesConversion.									*
 * -------------------									*
 * Converts Java types to gdbms and gvsig types		 	*
 * 														* 
 * PRODEVELOP 2008										*
 * @author Carlos Snchez (csanchez@prodevelop.es)		*
 ********************************************************/
public class GPETypesConversion {

	public static Value fromJavaTogvSIG(Object obj){
		if (obj instanceof String){
			return ValueFactory.createValue((String)obj);
		}
		if (obj instanceof Integer){
			return ValueFactory.createValue(((Integer)obj).intValue());
		}
		if (obj instanceof Double){
			return ValueFactory.createValue(((Double)obj).doubleValue());
		}
		if (obj instanceof Float){
			return ValueFactory.createValue(((Float)obj).floatValue());
		}
		if (obj instanceof Long){
			return ValueFactory.createValue(((Long)obj).longValue());
		}
		if (obj instanceof Boolean){
			return ValueFactory.createValue(((Boolean)obj).booleanValue());
		}
		return ValueFactory.createNullValue();
	}	
}
