/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

package es.prodevelop.gvsig.mobile.gpe.writer;

import java.io.IOException;
import org.gvsig.gpe.parser.ICoordinateIterator;

/**
 * Implements ICoordinateIterator to get the coordinates form geometries inside the features.												
 *														 
 * <br>2008 PRODEVELOP SL</br> 
 * @author Carlos Snchez Perin <br>csanchez@prodevelop.es</br>
 */

public class WriterPointsIterator implements ICoordinateIterator {

	int i=0;
	double[] x = null;
	double[] y = null;
	double[] z = null;
	int numcoords = 0;
		
	public WriterPointsIterator(double[] ordenada, double[] abcisa,double[] zeta) {
		super();
		x=ordenada;
		y=abcisa;
		z=zeta;
		numcoords = x.length;
	}

	public int getDimension() {
		return 3;
	}

	public boolean hasNext() throws IOException {
		if (i<numcoords)
			return true;
		else
			return false;	
	}

	public void next(double[] buffer) throws IOException {
		buffer[0]=x[i];
		buffer[1]=y[i];
		buffer[2]=z[i];
		i++;
	}
}
