package org.gvsig.gpe.gpx.parser.v11.header;

import java.util.Hashtable;

import javax.xml.namespace.QName;

import org.gvsig.gpe.gpx.exceptions.GpxHeaderParseException;
import org.gvsig.gpe.gpx.exceptions.GpxNotRootTagException;
import org.gvsig.gpe.gpx.parser.GPEDefaultGpxParser;
import org.gvsig.gpe.gpx.utils.GPXUtilsParser;
import org.gvsig.gpe.gpx.utils.GpxTags;
import org.gvsig.gpe.xml.stream.IXmlStreamReader;
import org.gvsig.gpe.xml.stream.XmlStreamException;
import org.gvsig.gpe.xml.utils.CompareUtils;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

public class HeaderBinding {
	
	/**
	 * This method parses the gpx header file
	 * @throws GpxHeaderParseException
	 */
	public String parse(IXmlStreamReader parser,GPEDefaultGpxParser handler) throws XmlStreamException, GpxHeaderParseException{
		String namespace = GpxTags.UNKNOWN_VERSION;
		try {	
			while(parser.getEventType()!= IXmlStreamReader.START_ELEMENT){
				parser.next();
			}
			QName name = parser.getName();	
			if (CompareUtils.compareWithOutNamespace(name,GpxTags.ROOT)==false){
				throw new GpxNotRootTagException(name);
			}
			
			for (int i=0 ; i<parser.getAttributeCount() ; i++){
				if (CompareUtils.compareWithOutNamespace(parser.getAttributeName(i), GpxTags.VERSION)){
					if(parser.getAttributeValue(i).compareTo("1.1") == 0){
						namespace = "http://www.topografix.com/GPX/1/1";
					}
					else if(parser.getAttributeValue(i).compareTo("1.0") == 0){
						namespace = "http://www.topografix.com/GPX/1/0";
					}
				}
			}
		} catch (Exception e) {
			throw new GpxHeaderParseException(e);
		} 
		return namespace;
	}
}
