package org.gvsig.mobile.location.test;

import gnu.io.CommPortIdentifier;
import java.util.Enumeration;

import org.dinopolis.gpstool.gpsinput.GPSException;
import org.dinopolis.gpstool.gpsinput.GPSRawDataListener;
import org.gvsig.mobile.location.GPSManager;
import org.gvsig.mobile.location.listener.GPSRelevantEventsListener;

public class SimpleCommLocationListener
	implements GPSRelevantEventsListener, GPSRawDataListener {

	public void gpsNewAltitude(double altitude) {
		// TODO Auto-generated method stub

	}

	public void gpsNewHeading(double heading) {
		// TODO Auto-generated method stub

	}

	public void gpsNewPDOP(double pdop) {
		// TODO Auto-generated method stub

	}

	public void gpsNewPosition(double longitude, double latitude) {
		String northing, easting;
		if (longitude >= 0)
			easting = "W";
		else
			easting = "E";
		if (latitude >= 0)
			northing = "N";
		else
			northing = "S";
		System.out.println("New location: " + latitude + northing +
				", " + longitude + easting);
	}

	public void gpsNewQuality(int quality) {
		// TODO Auto-generated method stub

	}

	public void gpsNewRMS(double rms) {
		// TODO Auto-generated method stub

	}

	public void gpsNewSatsUsed(int satUsed) {
		// TODO Auto-generated method stub

	}

	public void gpsNewStarfire(int starfire) {
		// TODO Auto-generated method stub

	}

	public void gpsNewStatus(int status) {
		// TODO Auto-generated method stub

	}

	/*
	 * Raw data may be interesting to know whether the serial port is actually
	 * listening to the GPS
	 */
	public void gpsRawDataReceived(char[] buffer, int offset, int length) {
		System.out.println("Received NMEA data: " + new String(buffer, offset, length));
	}

	/**
	 * A sample to show a simple use of libLocation
	 * Uses a comm port as location source and implements some
	 * events of GPSRelevantEventsListener
	 *
	 * Please set -Djava.library.path to lib/OS_ARCH according to
	 * the right OS and ARCHitechture, or use the provided
	 * SimpleCommLocationListener.launch launch configuration
	 *
	 * @param args
	 */
	public static void main(String[] args) {
		GPSManager gpsManager = GPSManager.getGPSManager();
		// Set device type: serial port
		gpsManager.setDeviceType(GPSManager.SERIAL_PORT_DEVICE);
		// Set comm port to the first comm port of the System
		String portName = null;
		Enumeration portList = CommPortIdentifier.getPortIdentifiers();
		while (portList.hasMoreElements()) {
			CommPortIdentifier portId = (CommPortIdentifier) portList.nextElement();
			if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {
				portName = portId.getName();
				System.out.println("Using first detected serial port: " + portName);
				break;
			}
		}
		if (portName != null) {
			// Set port name
			gpsManager.setPortName(portName);
			// Set baud rate
			gpsManager.setBaudRate(9600);
			// Instantiate the class that receives events
			SimpleSimLocationListener listener = new SimpleSimLocationListener();
			// Add this class as event listener
			gpsManager.addGPSRelevantEventsListener(listener);
			// Add this class as raw data listener
			gpsManager.addGPSRawDataListener(listener);
		try {
				// Connect to GPS
				gpsManager.connectToGPS();
			} catch (GPSException e) {
				System.err.println("ERROR trying to connect to the GPS: "
						+ e.getMessage());
			}
		}
		// Wait for events endlessly
		while (true) {}
	}

}
