/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *
 */

package gnu.io;

import java.util.EventListener;

/**
 * @author juangui
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public interface CommPortOwnershipListener extends EventListener {
	//The port just went from owned to unowned state, when the port's owner
	//called CommPort.close
	public static final int PORT_UNOWNED = 0;
	//Ownership contention. The port is owned by one application and another
	//application wants ownership. If the owner of this port is listening to
	//this event, it can call CommPort.close during the processing of this event
	//and thereby give up ownership of the port.
	public static final int PORT_OWNERSHIP_REQUESTED = 1;
	//The port just went from unowned to owned state, when an application
	//successfully called CommPortIdentifier.open
	public static final int PORT_OWNED = 2;

	/*Propagates a CommPortOwnership event. This method will be called with the type
	 * set to one of the variables PORT_OWNED, PORT_UNOWNED,
	 * or PORT_OWNERSHIP_REQUESTED.
	 */
	public void ownershipChange(int type);
}
