/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *
 */

package gnu.io;

import java.util.EventObject;

/**
 * @author juangui
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SerialPortEvent extends EventObject {
	public int eventType;
	//Deprecated. Replaced by getEventType method.
	//The type of event.

	public static final int DATA_AVAILABLE = 0;
    //Data available at the serial port. This event will be generated once when
	//new data arrive at the serial port. Even if the user doesn't read the data,
	//it won't be generated again until next time new data arrive.
	public static final int OUTPUT_BUFFER_EMPTY = 1;
    //Output buffer is empty. The event will be generated after a write is
	//completed, when the system buffer becomes empty again.
	public static final int CTS = 2;
    //Clear to send.
	public static final int DSR = 3;
	//Data set ready.
	public static final int RI = 4;
	//Ring indicator.
	public static final int CD = 5;
    //Carrier detect.
	public static final int OE = 6;
	//Overrun error.
	public static final int PE = 7;
	//Parity error.
	public static final int FE = 8;
	//Framing error.
	public static final int BI = 9;
	//Break interrupt.

	/*
	 * Constructs a SerialPortEvent with the specified serial port, event type,
	 * old and new values. Application programs should not directly create
	 * SerialPortEvent objects.
	 * Parameters:
	 *  srcport - source parallel port
	 *  eventtype - event type
	 *  oldvalue - old value
	 *  newvalue - new value
	 */
	public SerialPortEvent(SerialPort srcport, int eventtype, boolean oldvalue,
            boolean newvalue) {
		super(srcport);
	}

}
